﻿	/************************************************************ 
	/ Auteurs : DELOISON Matthieu								/ 
	/ Fonction : Formulaire Envoie de Mail						/
	/															/
	/ Date de création : 31/01/2006  							/
	/ Date de mise à jour : 01/--/2005  						/ 
	************************************************************/


/* NOTES :
* 

*/
import com.delfiweb.utils.*;
import com.delfiweb.error.*;
import com.delfiweb.command.*;

//import mx.transitions.easing.*;
import com.robertpenner.easing.*;

/**
* Point d'entrée du programme, Compatible MTASC (MotionTwin ActionScript 2 Compiler)
* 
* @class PMain
* @author Claude François
* @version 0.1
*/
class PMail
{
	
	/*----------- Composants de la scène ------------*/
	private static var _instance:PMail; 		// L'instance unique du singleton
	public var isLocal:Boolean; 				// Est-t'on en local ?
	public var isDebug:Boolean; 				// Active-t'on le debug ?
	private var _main:MovieClip; 				// Pointeur sur le niveau	

		
	/*----- ConstantMes ------*/
	private var _niveau:Number;				// la profondeur des movies clips		
	private var _ParserM;
	private var _sceneMail:MovieClip;
	private var _colortxt;
	private var _colortxtOver;
	private var _colorBtnOver;
	private var _colorwarning;

	
	private var _appel;
	private var _timeOut;
	private var _receptMail:LoadVars;	
	
	
	/*----- Gestion du ParserM -----------*/
	private var _xml; 								// stock le noeud xml a envoyer		

	
	/**
	* Constructeur privé, réalise la plupart des initialisations du programme, appelle ensuite
	* la méthode <b>_init</b> qui est la fonction de lancement autonome du programme, à utiliser
	* avec le PGameController
	* 
	* @method PMain 
	* @return Void
	*/
	private function PMail ()
	{
		// si le parametre version n'est pas transmis on est en local
		isLocal = (_root.version == undefined) ? true : false;		
		// si on est en local le debug est donc activé, sinon c'est en fonction du parametre php
		isDebug = (isLocal) ? true : ((_root.debug != undefined) ? true : false); 
		

		// on s'inscrit comme écouteur du diffuseur d'erreur
		ErrorDispatcher.addListener(this);
		
		// on stocke un pointeur sur le niveau
		_main = _root;
		
		isDebug = false;
		isLocal = false;
		
		if(isLocal)
		{
			trace("---- mode local ----")
			_root.ficphp = "mail.php";

		}

	}
	
	/**
	* C'est le point d'entrée du programme, appelé sur la première image du fla,
	* elle est compatible MTASC
	* 
	* @usage	PMain.main()
	* @method 	static main
	* @return 	Void
	*/
	public static function main ()
	{
		if(_instance == undefined)
		{
			_instance = new PMail();
			_instance._init();
		}
	}
	
	/**
	* C'est la qu'on fera le vrai setup du programme, prévue pour une utilisation avec 
	* le nouveau Debugger
	* 
	* @usage 	PMain.instance._init()
	* @method 	_init
	* @return 	Void
	*/
	public function _init()
	{
		
		_niveau = 10;
		/*--- initialisation de toutes les variables ---*/	
		_ParserM = ParserM.getInstance();

		//_root.attachMovie("background", "background", 3000,{_x:1, _y:1});

		_sceneMail = _main.createEmptyMovieClip("contenair",_niveau++);
		
		// configuration des couleurs du texte
		_colortxt = "0x999999";
		_colortxtOver = "0x0066ff";
		_colorBtnOver = "0xffffff";
		_colorwarning = "0xff0000";
		
		jouer ()
	}
		
		
		
	/**
	 *	Cette fonction lance tout d'abord la vérification
	 *  de doublon flash
	 * 
	 *	@usage		PMain.instance.jouer()
	 *	@method		jouer
	 *	@return		Void
	 */
	public function jouer ()
	{
		jouerOn ();
	}
	
	
	
	/**
	 *	>ette fonction lance tout d'abord la vérification
	 *  de doublon flash
	 * 
	 *	@usage		PMain.instance.jouer()
	 *	@method		jouer
	 *	@return		Void
	 */
	public function rejouer()
	{
		jouer();
	}
	
	
	
	/**
	 *	Appelé si aucune instance du flash n'existe 
	 * 
	 *	@usage		jouerOn()
	 *	@method		jouerOn
	 *	@return		Void
	 */
	public function jouerOn ()
	{	
		persoMenu();
		
		/*--- Décode le fichier XML ---*/
		_xml = new XML();
		_xml.ignoreWhite = true;
		_xml.onLoad = function()
		{
			PMail.instance._ParserM.parseXML (PMail.instance._xml)
		}
		if(isLocal) creerScene()//_xml.load("strings.xml");
		else _xml.load(_root.urlFicXML+"?killcache="+Math.floor(Math.random()*100));

	}
	
			
	
	// fonction lance la construction du mail (après le parse des Strings)
	public function contructOn()
	{
		creerScene()
	}
	
	
	
	/**
	* @property instance (PMain) L'instance unique de la classe PMain (read-only)
	*/
	public static function get instance ():PMail
	{
		return _instance;
	}
	
	
	
	/*--------------------------------------------------------------------------*/
	/*------------- Chargement des fichiers XML ------------------------------*/
	/*--------------------------------------------------------------------------*/
	
	
	/**
	* Récupère les évènements de l'ErrorDispatcher afin de les diffusés on de gérer les
	* exceptions du programme.
	*
	* @method onError
	* @param e (Error) 		Un objet Error
	*/
	function onError (e)
	{

	}
		
	
	
	
	/*----------------------------------------------------------*/
	/*---------------- Mise en page ----------------------------*/
	/*----------------------------------------------------------*/
	
	
	function creerScene()
	{
		var hMail:Number = 30;
		
		_sceneMail.attachMovie("nomChamps","Tpseudo", _niveau++,{_x:-250, _y:10});
		_sceneMail.Tpseudo.contenu = _global.Strings[0];
		
		_sceneMail.attachMovie("nomChamps","Texpediteur", _niveau++,{_x:_sceneMail.Tpseudo._x, _y:_sceneMail.Tpseudo._y+hMail});
		_sceneMail.Texpediteur.contenu = _global.Strings[1];
		
		_sceneMail.attachMovie("nomChamps","Tsujet", _niveau++,{_x:_sceneMail.Tpseudo._x, _y:_sceneMail.Texpediteur._y+hMail});
		_sceneMail.Tsujet.contenu = _global.Strings[2];
		
		_sceneMail.attachMovie("nomChamps","Tmessage", _niveau++,{_x:_sceneMail.Tpseudo._x, _y:_sceneMail.Tsujet._y+hMail});
		_sceneMail.Tmessage.contenu = _global.Strings[3];
		
		_sceneMail.attachMovie("contenuChamps","Cpseudo", _niveau++,{_x:670, _y:_sceneMail.Tpseudo._y});
		_sceneMail.Cpseudo.contenu = _global.Strings[4];
		
		_sceneMail.attachMovie("contenuChamps","Cexpediteur", _niveau++,{_x:_sceneMail.Cpseudo._x, _y:_sceneMail.Texpediteur._y});
		_sceneMail.Cexpediteur.contenu = _global.Strings[5];
		
		_sceneMail.attachMovie("contenuChamps","Csujet", _niveau++,{_x:_sceneMail.Cpseudo._x, _y:_sceneMail.Tsujet._y});
		_sceneMail.Csujet.contenu = _global.Strings[6];
		
		_sceneMail.attachMovie("messageMail","Cmessage", _niveau++,{_x:-450, _y:_sceneMail.Tmessage._y+hMail});
		_sceneMail.Cmessage.contenu = _global.Strings[7];
		
		_sceneMail.attachMovie("btnOver","btnOverAnnuler", _niveau++,{_x:165, _y:_sceneMail.Cmessage._y+140, _alpha:0});
		_sceneMail.attachMovie("btn","btnAnnuler", 72,{_x:-275, _y:_sceneMail.btnOverAnnuler._y});
		_sceneMail.btnAnnuler.contenu = _sceneMail.btnOverAnnuler.contenu = _global.Strings[11];
		_sceneMail.btnOverAnnuler.txtinput.textColor = _colorBtnOver;
		_sceneMail.btnAnnuler.txtinput.textColor = _colortxt;
		
		_sceneMail.attachMovie("btnOver","btnOverEnvoyer", _niveau++,{_x:290, _y:_sceneMail.btnOverAnnuler._y, _alpha:0});
		_sceneMail.attachMovie("btn","btnEnvoyer", _niveau++,{_x:600, _y:_sceneMail.btnOverAnnuler._y});
		_sceneMail.btnEnvoyer.contenu = _sceneMail.btnOverEnvoyer.contenu = _global.Strings[12];
		_sceneMail.btnOverEnvoyer.txtinput.textColor = _colorBtnOver;
		_sceneMail.btnEnvoyer.txtinput.textColor = _colortxt;
		
		//_sceneMail.attachMovie("titre","titre", _niveau++,{_x:700, _y:10});
		//_sceneMail.titre.contenu = _global.Strings[21];
		
		
		animerScene();
		
	}
	
	
	
	
	// fonction : aimation de la scène
	function animerScene()
	{
		// partie gauche
		var xGcheFin:Number = 10;		
		new mx.transitions.Tween (_sceneMail.Tpseudo, "_x" ,Elastic.easeOut, _sceneMail.Tpseudo._x, xGcheFin,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.Texpediteur, "_x" ,Elastic.easeOut, _sceneMail.Texpediteur._x, xGcheFin,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.Tsujet, "_x" ,Elastic.easeOut, _sceneMail.Tsujet._x, xGcheFin,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.Tmessage, "_x" ,Elastic.easeOut, _sceneMail.Tmessage._x, xGcheFin,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.btnAnnuler, "_x" ,Elastic.easeOut, _sceneMail.btnAnnuler._x, _sceneMail.btnOverAnnuler._x,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.Cmessage, "_x" ,Elastic.easeOut, _sceneMail.Cmessage._x, xGcheFin,ConstantM.DUREEANIMTXT, true )	
		
		// partie droite
		var xDteFin:Number = 150;		
		new mx.transitions.Tween (_sceneMail.Cpseudo, "_x" ,Elastic.easeOut, _sceneMail.Cpseudo._x, xDteFin,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.Cexpediteur, "_x" ,Elastic.easeOut, _sceneMail.Cexpediteur._x, xDteFin,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.Csujet, "_x" ,Elastic.easeOut, _sceneMail.Csujet._x, xDteFin,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.btnEnvoyer, "_x" ,Elastic.easeOut, _sceneMail.btnEnvoyer._x, _sceneMail.btnOverEnvoyer._x,ConstantM.DUREEANIMTXT, true )	
		new mx.transitions.Tween (_sceneMail.titre, "_x" ,Elastic.easeOut, _sceneMail.titre._x, 10,ConstantM.DUREEANIMTXT, true )	
		
		
		
		// gestion des actions
		_sceneMail.Cpseudo.txtinput.onSetFocus = Delegate.create(this,_onCpseudoClik).getFunction();
		_sceneMail.Cexpediteur.txtinput.onSetFocus = Delegate.create(this,_onCexpediteurClik).getFunction();
		_sceneMail.Csujet.txtinput.onSetFocus = Delegate.create(this,_onCsujetClik).getFunction();
		_sceneMail.Cmessage.txtinput.onSetFocus = Delegate.create(this,_onCmessagClik).getFunction();
		
		
		// actions et effets sur les boutons
		_sceneMail.btnAnnuler.onRelease = Delegate.create(this,_onBtnReleaseAnnuler).getFunction();
		_sceneMail.btnAnnuler.onRollOver = Delegate.create(this,_onBtnRollOverAnnuler).getFunction();
		_sceneMail.btnAnnuler.onRollOut = Delegate.create(this,_onBtnRollOutAnnuler).getFunction();
		
		_sceneMail.btnEnvoyer.onRelease = Delegate.create(this,_onBtnReleaseEnvoyer).getFunction();
		_sceneMail.btnEnvoyer.onRollOver = Delegate.create(this,_onBtnRollOverEnvoyer).getFunction();
		_sceneMail.btnEnvoyer.onRollOut = Delegate.create(this,_onBtnRollOutEnvoyer).getFunction();
	
	}
	
	
	
	/*----------------------------------------------------------*/
	/*------------- Gestion des boutons ------------------------*/
	/*----------------------------------------------------------*/
	
	
	/*--- les SetFocus ---*/
	function _onCpseudoClik()
	{
		
		if (_sceneMail.Cpseudo.contenu == _global.Strings[4]) _sceneMail.Cpseudo.contenu = "";

		_sceneMail.Cpseudo.txtinput.textColor  = _colortxtOver;
		_sceneMail.Cexpediteur.txtinput.textColor  = _colortxt;
		_sceneMail.Csujet.txtinput.textColor  = _colortxt;
		_sceneMail.Cmessage.txtinput.textColor  = _colortxt;

		
	}
	
	function _onCexpediteurClik()
	{
		if (_sceneMail.Cexpediteur.contenu == _global.Strings[5] || _sceneMail.Cexpediteur.contenu == _global.Strings[8] ) _sceneMail.Cexpediteur.contenu = "";
		
		_sceneMail.Cpseudo.txtinput.textColor  = _colortxt;
		_sceneMail.Cexpediteur.txtinput.textColor  = _colortxtOver;
		_sceneMail.Csujet.txtinput.textColor  = _colortxt;
		_sceneMail.Cmessage.txtinput.textColor  = _colortxt;
		
	}
	
	function _onCsujetClik()
	{
		if (_sceneMail.Csujet.contenu == _global.Strings[6]) _sceneMail.Csujet.contenu = "";
		
		_sceneMail.Cpseudo.txtinput.textColor  = _colortxt;
		_sceneMail.Cexpediteur.txtinput.textColor  = _colortxt;
		_sceneMail.Csujet.txtinput.textColor  = _colortxtOver;
		_sceneMail.Cmessage.txtinput.textColor  = _colortxt;
		
		
	}
	
	function _onCmessagClik()
	{
		if (_sceneMail.Cmessage.contenu == _global.Strings[7]) _sceneMail.Cmessage.contenu = "";
		
		_sceneMail.Cpseudo.txtinput.textColor  = _colortxt;
		_sceneMail.Cexpediteur.txtinput.textColor  = _colortxt;
		_sceneMail.Csujet.txtinput.textColor  = _colortxt;
		_sceneMail.Cmessage.txtinput.textColor  = _colortxtOver;

	}
	
	
	/*--- Bouton annuler ---*/
	function _onBtnReleaseAnnuler()
	{
		_sceneMail.Cpseudo.contenu = _global.Strings[4];
		_sceneMail.Cexpediteur.contenu = _global.Strings[5];
		_sceneMail.Csujet.contenu = _global.Strings[6];
		_sceneMail.Cmessage.contenu = _global.Strings[7];
	}
	
	
	function _onBtnRollOverAnnuler()
	{
		_sceneMail.btnOverAnnuler._alpha = 100;
		_sceneMail.btnAnnuler.contenu = "";
		_sceneMail.btnOverAnnuler.contenu = _global.Strings[11];
		_sceneMail.btnAnnuler._alpha = 0;
	}
	
	
	function _onBtnRollOutAnnuler()
	{
		_sceneMail.btnOverAnnuler._alpha = 0;
		_sceneMail.btnAnnuler._alpha = 100;
		_sceneMail.btnAnnuler.contenu = _global.Strings[11];
		_sceneMail.btnOverAnnuler.contenu = "";
		
	}
		
	
	
	/*--- Bouton envoyer ---*/
	function _onBtnReleaseEnvoyer()
	{
		       
		var pseudoP:String = _sceneMail.Cpseudo.contenu;
		var expediteurP:String = _sceneMail.Cexpediteur.contenu;
		var sujetP:String = _sceneMail.Csujet.contenu;
		var msgmailP:String = _sceneMail.Cmessage.contenu;
		
		var envoieOK:Boolean = true;
		/*--- Vérification des champs du formulaire ---*/
		if( pseudoP == undefined || pseudoP == _global.Strings[4] || pseudoP == "")
		{
			envoieOK = false;
			_sceneMail.Cpseudo.contenu = _global.Strings[4];
			_sceneMail.Cpseudo.txtinput.textColor  = _colorwarning;
			
		}
		if( expediteurP == undefined || expediteurP == _global.Strings[5] || expediteurP == "")
		{
			envoieOK = false;
			_sceneMail.Cexpediteur.contenu = _global.Strings[5];
			_sceneMail.Cexpediteur.txtinput.textColor  = _colorwarning;
			
		}
		if( sujetP == undefined || sujetP == _global.Strings[6] ||  sujetP == "")
		{
			envoieOK = false;
			_sceneMail.Csujet.contenu = _global.Strings[6];
			_sceneMail.Csujet.txtinput.textColor  = _colorwarning;
			
		}
		if( msgmailP == undefined || msgmailP == _global.Strings[7] || msgmailP == "")
		{
			envoieOK = false;
			_sceneMail.Cmessage.contenu = _global.Strings[7];
			_sceneMail.Cmessage.txtinput.textColor  = _colorwarning;
			
		}
		
		
		/*--- Vérification de l'@mail ---*/
		var mailValide:Boolean = true;
		var extensionMail:String = expediteurP.substring (expediteurP.lastIndexOf (".") + 1, expediteurP.length);
				
		if(expediteurP.lastIndexOf ("@") < 2) mailValide=false;
		else if(expediteurP.lastIndexOf (".") < 2) mailValide=false;
		else if(expediteurP.length < 8) mailValide=false;
		else if(extensionMail.length < 2) mailValide=false;
		else if( !isNaN (parseFloat(extensionMail)) ) mailValide=false;
		else if(expediteurP.length - expediteurP.lastIndexOf (".") < 3) mailValide=false;
		else if(expediteurP.lastIndexOf (".") - expediteurP.lastIndexOf ("@") <= 3) mailValide=false;
		
		if(!mailValide)
		{
			envoieOK = false;
			_sceneMail.Cexpediteur.contenu = _global.Strings[8];
			_sceneMail.Cexpediteur.txtinput.textColor  = _colorwarning;
		}
		
		
		//new AppelURLCommand ("http://matthieu.deloison.free.fr","_blank", "POST", {pseudo:pseudoP, expediteur:expediteurP, sujet:sujetP, msgmail:msgmailP, nocache:random(100)}).execute();		
		
		/*--- Envoie du mail via php ---*/
		if(envoieOK)
		{
			var middle = new mx.transitions.Tween (_sceneMail, "_x" ,Linear.easeOut, _sceneMail._x, 650,ConstantM.DUREEANIMMIDDLE, true )	
			middle.onMotionFinished = Delegate.create(this,_commFichierPhp).getFunction();
			
		}
		
		
		
	}
	
	
	
	// fonction : envoie du mail à l'aide du fichier php
	function _commFichierPhp()
	{		
		_root.pseudo = _sceneMail.Cpseudo.contenu;
		_root.expediteur = _sceneMail.Cexpediteur.contenu;
		_root.sujet = new ReplaceString (_sceneMail.Csujet.contenu).arrayReplace (["à","ç","è","é","ê","ë","î","ô","ù"], ["33zz","44zz","55zz","66zz","77zz","88zz","99zz","1122zz","2211zz"] );
		_root.msgmail = new ReplaceString (_sceneMail.Cmessage.contenu).arrayReplace (["’","\r"," ","à","ç","è","é","ê","ë","î","ô","ù"], ["34zz","11zz","22zz","33zz","44zz","55zz","66zz","77zz","88zz","99zz","1122zz","2211zz"] );
		
		//Création de Objet loadvars pour l'envoie des données du formulaire
		_receptMail = new LoadVars();
		_receptMail.pseudo = _sceneMail.Cpseudo.contenu;
		_receptMail.expediteur = _sceneMail.Cexpediteur.contenu;
		_receptMail.sujet = new ReplaceString (_sceneMail.Csujet.contenu).arrayReplace (["à","ç","è","é","ê","ë","î","ô","ù"], ["33zz","44zz","55zz","66zz","77zz","88zz","99zz","1122zz","2211zz"] );
		_receptMail.msgmail = new ReplaceString (_sceneMail.Cmessage.contenu).arrayReplace (["’","\r"," ","à","ç","è","é","ê","ë","î","ô","ù"], ["34zz","11zz","22zz","33zz","44zz","55zz","66zz","77zz","88zz","99zz","1122zz","2211zz"] );
		//Création d'une variable aléatoire pour les problèmes de cache
		_receptMail.alearoire = Math.floor(Math.random()*100)
		
		_sceneMail.removeMovieClip();
		_sceneMail = _main.createEmptyMovieClip("contenair",10);
		_sceneMail.attachMovie("envoieEnCours","envoieEnCours",_niveau++, {_x:5 ,_y:110 })
		_sceneMail.envoieEnCours.contenu = _global.Strings[22];
		
		// Envoie des informations
		_receptMail.sendAndLoad(_root.ficphp, _receptMail,"POST");
		
		// le serveur php renvoie la réponse
		_receptMail.onLoad = Delegate.create(this,affResult).getFunction();
		
	}
	
	
	// fonction : reçoit la réponse du fichier php
	function affResult()
	{		
		_sceneMail.removeMovieClip();
		_sceneMail = _main.createEmptyMovieClip("contenair",_niveau++);
		_sceneMail.attachMovie("titre","titre",_niveau++, {_x:5 ,_y:110 })
		_sceneMail.titre.contenu = "<b>"+_receptMail.reponse+"</b>";
	}
	
	
	
	function _onBtnRollOverEnvoyer()
	{
		_sceneMail.btnOverEnvoyer._alpha = 100;
		_sceneMail.btnEnvoyer._alpha = 0;
		_sceneMail.btnEnvoyer.contenu = "";
		_sceneMail.btnOverEnvoyer.contenu = _global.Strings[12];
	}
	
	
	function _onBtnRollOutEnvoyer()
	{
		_sceneMail.btnOverEnvoyer._alpha = 0;
		_sceneMail.btnEnvoyer._alpha = 100;
		_sceneMail.btnEnvoyer.contenu =  _global.Strings[12];
		_sceneMail.btnOverEnvoyer.contenu = "";
	}
	
	
	/*----------------------------------------------------------*/
	/*------------- Copyright ----------------------------------*/
	/*----------------------------------------------------------*/
	
	
	// fonction : personnalisation du menu flash
	function persoMenu()
	{
		//trace("perso menu")
		Stage.showMenu = true;
		var menuPerso:ContextMenu = new ContextMenu()

		menuPerso.hideBuiltInItems(); // cacher le menu d'origine
		
		var m1:ContextMenuItem = new ContextMenuItem("Auteur", Delegate.create(PMail.instance,_mail).getFunction())
		//var m2:ContextMenuItem = new ContextMenuItem("Book", function(){})
		
		//m2.separatorBefore = true;// insérer une séparation
		
		menuPerso.customItems = [m1];
		//menuPerso.customItems = [m1,m2];
		_root.menu = menuPerso; // mettre à jour le menu
	}
	
	
	// fonction : personnalisation du menu flash - contact me
	function _mail() 
	{
		new AppelURLCommand ("http://matthieu.deloison.free.fr","_blank", "GET", {nocache:random(1000)}).execute();		
	}
	
	
	/*----------------------------------------------------------*/
	/*------------- Divers -------------------------------------*/
	/*----------------------------------------------------------*/
	

	
	
}// fin de la classe